unit chatlaninserv;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ScktComp, ExtCtrls;

type
  TServerForm = class(TForm)
    UsersListBox: TListBox;  //    
    ServerSocket1: TServerSocket;   //
    StartButton: TButton;       //
    StopButton: TButton;   //
    PortEdit: TEdit;     //
    PortLabel: TLabel;    //
    ServerLabel: TLabel;    //
    procedure StartButtonClick(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocket1ClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ServerForm: TServerForm;

implementation

{$R *.dfm}

procedure TServerForm.StartButtonClick(Sender: TObject);
var s: string;
  begin
    {  }
    UsersListBox.Items.Clear;
    { }
    ServerSocket1.Port := StrToInt(PortEdit.Text);
    { }
    ServerSocket1.Open;
    UsersListBox.Items.Add(' ');
  end;

procedure TServerForm.StopButtonClick(Sender: TObject);
begin
    {  }
    UsersListBox.Items.Clear;
    if ServerSocket1.Active then
     begin
     { }
     ServerSocket1.Close;
     UsersListBox.Items.Add('  :(');
     end;
  end;

procedure TServerForm.ServerSocket1ClientRead(Sender: TObject;
          Socket: TCustomWinSocket);
var s: string;
    i: Integer;
  begin
    {  }
    s := Socket.ReceiveText;
    {  }
    if Copy(s,1,2) = '^N' then begin
       Delete(s,1,2);
       {   }
       UsersListBox.Items.Add(s);
       { s     }
       s := '^U';

       for i := 0 to UsersListBox.Items.Count-1 do
       { }
         s := s+UsersListBox.Items[i]+';';
       {  }
       for i := 0 to ServerSocket1.Socket.ActiveConnections-1 do
          ServerSocket1.Socket.Connections[i].SendText(s);
       Exit;
  end;
    {  ,    }
    if (Copy(s,1,2) = '^M')or(Copy(s,1,2) = '^P') then begin
     for i := 0 to ServerSocket1.Socket.ActiveConnections-1 do
      ServerSocket1.Socket.Connections[i].SendText(s);
     Exit;
    end;
  end;
  
procedure TServerForm.ServerSocket1ClientDisconnect(Sender: TObject;
    Socket: TCustomWinSocket);
var i: Integer;
  begin
    {       }
    UsersListBox.Items.Clear;
    for i := 0 to ServerSocket1.Socket.ActiveConnections-1 do
     ServerSocket1.Socket.Connections[i].SendText('^N');
  end;

end.
